program WPChange;
{Copyright (c) 2000, Michal Cihar <cihar@email.cz>}
{This program is freeware}

{$MODE OBJFPC}
{$MODE DELPHI}
{$APPTYPE CONSOLE}

{define one of following to select language version version:
czechenc - czech with CP 852 (MS-DOS Latin 2)
czech - czech without accents
nothing defined - english}
{ $define czechenc}
{$DEFINE czech}

var
   s: string;
const
   null: char = #0;

function SystemParametersInfo(uiAction, uiParam: LongWord; pvParam: Pointer; fWinIni: LongWord):
   Boolean; stdcall; external 'user32.dll' name 'SystemParametersInfoA';

function GetLastError:LongWord; external 'kernel32.dll' name 'GetLastError';

procedure WriteError;
begin
{$IFDEF czechenc}
   writeln('WPChanger verze 1.0 - mni tapety - freeware');
   writeln('Copyright (c) 2000, Michal iha <cihar@email.cz>');
   writeln('Chyba pi mnn tapety: ',GetLastError);
   writeln('');
{$ELSE}
{$IFDEF czech}
   writeln('WPChanger verze 1.0 - menic tapety - freeware');
   writeln('Copyright (c) 2000, Michal Cihar <cihar@email.cz>');
   writeln('Chyba pri meneni tapety: ',GetLastError);
   writeln('');
{$ELSE}
   writeln('WPChanger version 1.0 - wallpaper changer - freeware');
   writeln('Copyright (c) 2000,  Michal Cihar <cihar@email.cz>');
   writeln('Error while changing wallpaper: ',GetLastError);
   writeln('');
{$ENDIF}
{$ENDIF}
end;

begin
   s := Paramstr(1);
   if (paramcount = 0) or ((s[1] in ['/', '-']) and (upcase(s[2]) in ['?', 'H'])) or (s = '--help')
      then
   begin
{$IFDEF czechenc}
      writeln('WPChanger verze 1.0 - mni tapety - freeware');
      writeln('Copyright (c) 2000, Michal iha <cihar@email.cz>');
      writeln('Pouit: WPChanger [soubor|/N|/?]');
      writeln('     /? zobraz tuto napovedu');
      writeln('     soubor - jmno souboru s novou tapetou (doporueno vetn cesty)');
      writeln('     /N - zru tapetu');
      writeln('   Pouv se jen prvn parametr, je jedno jestli pouijete / nebo - ');
      writeln('');
{$ELSE}
{$IFDEF czech}
      writeln('WPChanger verze 1.0 - menic tapety - freeware');
      writeln('Copyright (c) 2000, Michal Cihar <cihar@email.cz>');
      writeln('Pouziti: WPChanger [soubor|/N|/?]');
      writeln('     /? zobrazi tuto napovedu');
      writeln('     soubor - jmeno souboru s novou tapetou (doporuceno vcetne cesty)');
      writeln('     /N - zrusi tapetu');
      writeln('   Pouziva se jen prvni parametr, je jedno jestli pouzijete / nebo - ');
      writeln('');
{$ELSE}
      writeln('WPChanger version 1.0 - wallpaper changer - freeware');
      writeln('Copyright (c) 2000,  Michal Cihar <cihar@email.cz>');
      writeln('Use: WPChanger [filename|/N|/?]');
      writeln('     /? displays this help');
      writeln('     filename - filename of new wallpaper (recomended with path)');
      writeln('     /N - sets wallpaper to none');
      writeln('   Only first parameter is accepted, / and - are equal');
      writeln('');
{$ENDIF}
{$ENDIF}
   end
   else
      if ((s[1] in ['/', '-']) and (upcase(s[2]) = 'N')) then
      begin
         if SystemParametersInfo(20 {SPI_SETDESKWALLPAPER}, 0, @null, 1 {SPIF_UPDATEINIFILE}) then
         begin
{$IFDEF czechenc}
            writeln('WPChanger verze 1.0 - mni tapety - freeware');
            writeln('Copyright (c) 2000, Michal iha <cihar@email.cz>');
            writeln('Tapeta zruena');
            writeln('');
{$ELSE}
{$IFDEF czech}
            writeln('WPChanger verze 1.0 - menic tapety - freeware');
            writeln('Copyright (c) 2000, Michal Cihar <cihar@email.cz>');
            writeln('Tapeta zrusena');
            writeln('');
{$ELSE}
            writeln('WPChanger version 1.0 - wallpaper changer - freeware');
            writeln('Copyright (c) 2000,  Michal Cihar <cihar@email.cz>');
            writeln('Wallpaper cancelled');
            writeln('');
{$ENDIF}
{$ENDIF}
         end
         else
            WriteError;
      end
      else
      begin
         s:=s+null;
         if SystemParametersInfo(20 {SPI_SETDESKWALLPAPER}, 0,addr(s[1]), 1 {SPIF_UPDATEINIFILE})
            then
         begin
{$IFDEF czechenc}
            writeln('WPChanger verze 1.0 - mni tapety - freeware');
            writeln('Copyright (c) 2000, Michal iha <cihar@email.cz>');
            writeln('Nov tapeta je: ' + s);
            writeln('');
{$ELSE}
{$IFDEF czech}
            writeln('WPChanger verze 1.0 - menic tapety - freeware');
            writeln('Copyright (c) 2000, Michal Cihar <cihar@email.cz>');
            writeln('Nova tapeta je: ' + s);
            writeln('');
{$ELSE}
            writeln('WPChanger version 1.0 - wallpaper changer - freeware');
            writeln('Copyright (c) 2000,  Michal Cihar <cihar@email.cz>');
            writeln('New wallpaper is: ' + s);
            writeln('');
{$ENDIF}
{$ENDIF}
         end
         else
            WriteError;
      end;
end.

